package com.platform.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.platform.entity.SysUserEntity;
import com.platform.entity.UserWindowDto;
import com.platform.page.Page;

import java.util.List;
import java.util.Map;


/**
 * 系统用户
 *
 * @author lipengjun
 * @email 939961241@qq.com
 * @date 2016年9月18日 上午9:43:39
 */
public interface SysUserService {

    /**
     * 查询用户的所有权限
     *
     * @param userId 用户ID
     */
    List<String> queryAllPerms(Long userId);


    Long getUserNumOfDept(Long dptId);

    /**
     * 查询用户的所有菜单ID
     */
    List<Long> queryAllMenuId(Long userId);

    IPage<SysUserEntity> getSysUserList(List<Long> deptIdList , String key , long brandId,
                                        long pageNum , long pageSize);


    IPage<SysUserEntity> getCompanyStaffList(String staffName, String deptName,
                                             long pageNum, long pageSize , Long deptId, boolean excludeSuperAdmin);

    /**
     * 根据用户名，查询系统用户
     */
    SysUserEntity queryByUserName(String username);

    SysUserEntity queryByUserMobile(String mobile);

    SysUserEntity queryByMobileAndDeptId(String mobile , long deptId);

    /**
     * 根据用户ID，查询用户
     *
     * @param userId
     * @return
     */
    SysUserEntity queryObject(Long userId);

    /**
     * 查询用户列表
     */
    List<SysUserEntity> queryList(Map<String, Object> map);

    /**
     * 查询总数
     */
    int queryTotal(Map<String, Object> map);

    /**
     * 保存用户
     */
    void save(SysUserEntity user);

    public void addNewUserWithoutCheck(SysUserEntity user);

    /**
     * 修改用户
     */
    void update(SysUserEntity user);

    void updateOnly(SysUserEntity user);

    int updateUserAndAddDeptAdminRolls(SysUserEntity userEntity);

    /**
     * 删除用户
     */
    void deleteBatch(Long[] userIds);

    /**
     * 修改密码
     *
     * @param userId      用户ID
     * @param password    原密码
     * @param newPassword 新密码
     */
    void updatePassword(String mobile, String password, String newPassword, String fdkkUser);

    /**
     * 根据条件分页查询
     * @param userEntity
     * @param pageNum
     * @return
     */
    Page<UserWindowDto> findPage(UserWindowDto userEntity, int pageNum);

    public List<SysUserEntity> getSysUserListByDeptIds(List<Long> deptList);
}
